 require 'sketchup.rb' 
 include Math
 
 class Circle_any_plan
 
 def initialize
   @f_point = Geom::Point3d.new
   @sec_point = Geom::Point3d.new 
   @thr_point = Geom::Point3d.new
   @inputpoints = []
   #@drawn = false
   @cir_segment = 36
 end 
 
 def activate  
	self.reset
	
 end 
 
 def reset
	@inputpoints = []
	@GetPoint = Sketchup::InputPoint.new 
    @ip1 = Sketchup::InputPoint.new 
	@ip2 = Sketchup::InputPoint.new 
	@ip3 = Sketchup::InputPoint.new 
	@n_click = 0 
	@Override = false
	@value = 0
	@drawed = false
    puts "reset"
	
	if(@cent_cline!=nil && !@cent_cline.deleted?)				#del construction line
		@cent_cline.erase!
		@cent_cline=nil
	end
 end 
 
 def deactivate(view)
     puts "deactive call"
 end 
  
 def onLButtonDown(flags, x, y, view)
    @GetPoint = view.inputpoint x, y 
    case @n_click
	when 0

		@inputpoints.push(@GetPoint)
		@f_point = @inputpoints[0].position 
		puts "@f_point = #{@f_point}"
		@n_click = @n_click + 1
		
	when 1
	    @GetPoint.copy! @ip2 if(@ip2.valid?)
	    @inputpoints.push(@GetPoint)
		@sec_point = @inputpoints[1].position
        puts "@sec_point = #{@sec_point}"		
		@n_click = @n_click + 1
		puts "inputpoint length = #{@inputpoints.length}"
		view.lock_inference
	
	when 2
		@inputpoints.push(@GetPoint)
		drawCircle(@center,@dir_vec,@radius,view)
	    @n_click = @n_click + 1
		@cent_cline = Sketchup.active_model.entities.add_cline @f_point , @dir_vec   
	when 3
	     puts "Click n =3"
		#@inputpoints.push(@GetPoint)
		#cy_dist = (@inputpoints[3].position).distance @f_point
		#@cy_dist = (@cpt_l).distance @f_point
		status = @cir_face.pushpull @cy_dist,true
		Sketchup.active_model.entities.add_cpoint @f_point
		Sketchup.active_model.entities.add_cpoint @cpt_l
		group = Sketchup.active_model.active_entities.add_group             ### add group
		self.reset
	end 
	
 end 
 
 def onMouseMove(flags, x, y, view)
    
	if (@n_click ==0)
		@ip1.pick view, x, y
		view.tooltip = @ip1.tooltip if(@ip1.valid?)
	end 
	
	if (@n_click ==1)    #move find direction
		@ip2.pick view, x, y, @inputpoints[0]
		view.tooltip = @ip2.tooltip if(@ip2.valid?)
	end 
	
	if (@n_click==2)    #move find radius
		@ip2.pick view, x, y
		view.tooltip = @ip2.tooltip if(@ip2.valid?)
	end 
	
	if (@n_click==3)    #move find distance
		@ip3.pick view, x, y
		view.tooltip = @ip3.tooltip if(@ip3.valid?)
	end 
	
	view.invalidate 
 
 end 
 
 def draw(view)
     
	 if (@inputpoints.length ==1)
		view.draw_points(@f_point, 8, 1, "blue")
	    Sketchup::set_status_text("Click point for Axes direction")
		
		if(@ip2.valid?)
		Sketchup::set_status_text "Position",SB_VCB_LABEL
		temp_pt = @ip2.position 
        Sketchup::set_status_text temp_pt.x.to_s + "," + temp_pt.y.to_s + "," + temp_pt.z.to_s,SB_VCB_VALUE
		view.line_stipple = "_"
		view.set_color_from_line @f_point, @ip2
		view.draw_line @f_point, @ip2.position 
		end 
		
	 end 
	 if (@inputpoints.length ==2)
         previewShape(view)
         Sketchup::set_status_text "Click point of radius"  #show status of select radius
         Sketchup::set_status_text "Radius",SB_VCB_LABEL
         @radius = @f_point.distance @ip2.position
         Sketchup::set_status_text @radius.to_s,SB_VCB_VALUE
	 end 
     
	 if (@inputpoints.length ==3)							#find the length to pull
		if (@ip3.valid?)
			if (@cent_cline != nil)
			#temp_pt = @ip3.position
			@cpt_l= @ip3.position.project_to_line [@f_point,@dir_vec]   
			#view.line_stipple = "-"
			view.draw_points(@cpt_l, 12, 5, "red")
			view.drawing_color="red"
			#view.set_color_from_line @f_point, cpt_l
			#view.draw_line @f_point, cpt_l 
			view.draw(GL_LINE_STRIP, [@f_point,@cpt_l])
			@cy_dist = (@cpt_l).distance @f_point
			Sketchup::set_status_text "Click point to distance"
			Sketchup::set_status_text "Distance",SB_VCB_LABEL
			Sketchup::set_status_text @cy_dist.to_s,SB_VCB_VALUE
			end
		# view.line_stipple = "_"
		# view.set_color_from_line @f_point, @ip3
		# view.draw_line @f_point, @ip3.position 
		end
	 end
 end 
 
 def onLButtonUp(flags, x, y, view)
 
 end 
 
 def onKeyDown(key, repeat, flags, view)
     if( key == CONSTRAIN_MODIFIER_KEY && repeat == 1 )
        @shift_down_time = Time.now
        puts "Press shift"
        # if we already have an inference lock, then unlock it
        if( view.inference_locked? )
            # calling lock_inference with no arguments actually unlocks
            view.lock_inference
        elsif( @state == 0 && @ip1.valid? )
            view.lock_inference @ip1
        elsif( @n_click == 1 && @ip2.valid? )
            view.lock_inference @ip2, @GetPoint
        end
    end
 end 
 
 def onKeyUp(key, repeat, flags, view)
    if( key == CONSTRAIN_MODIFIER_KEY &&
        view.inference_locked? &&
        (Time.now - @shift_down_time) > 0.5 )
        view.lock_inference
    end
 end 
 
 def onUserText(text, view)
    
	return if not (@inputpoints.length == 2)
    return if not @ip2.valid?
   
    begin
        @value = text.to_l
		@Override = true
		
    rescue
        # Error parsing the text
        UI.beep
        puts "Cannot convert #{text} to a Length"
        value = nil
        Sketchup::set_status_text "", SB_VCB_VALUE
    end
    return if !@value
	puts "User text"
	puts "Value #{@value}"
	drawCircle(@center,@dir_vec,@value,view)
 end 
 
 def onCancel(flags,view)
 
 end 
 
 def previewShape(view)
            
      @center=@inputpoints[0].position
      normal=@inputpoints[0].normal
      
      @dir_vec = find_vec(@inputpoints[0],@inputpoints[1])
      v_axes = @dir_vec.axes
      
      plane = [@center,v_axes[2]]
   
      #project the input point on a plane described by our normal and center.
      vp=@ip2.position
      ep=vp.project_to_plane(plane)
	  #ep = Geom::intersect_line_plane ([view.camera.eye,@ip2],plane)
	   
      view.set_color_from_line(@center,ep)
      view.draw(GL_LINE_STRIP, [@center,ep])

      dir=@center.vector_to(ep).normalize
      forward = normal.axes[0]
      angleDelta=forward.angle_between(dir)
	  @numSegments = 36
      dot=forward.dot(dir)
      #	angleDelta = Math.acos(dot)
      if(dot<0)
        #puts angleDelta 
      else
        #puts -angleDelta
      end 
      radius=@center.distance(ep)

      angleDelta=0
	
      #if(@ctrlDown)
      #	center=@ip.position
      #end
	    
      @shapePoints=sp_points_on_circle(@center, @dir_vec, radius, @numSegments,angleDelta)
      @shapeRadius=radius
	
      view.drawing_color="blue"
	  view.line_stipple = "_"
      view.draw(GL_LINE_LOOP, @shapePoints)
      # if (@inputpoints.length == 3)
         # cover_shape = @shapePoints
         # return cover_shape
      # end
  end  
 def find_vec(begin_point,end_point)
      beg_pt = Geom::Point3d.new
      end_pt = Geom::Point3d.new
      beg_pt = begin_point.position
      end_pt = end_point.position
      d_x = end_pt.x-beg_pt.x
      d_y = end_pt.y-beg_pt.y
      d_z = end_pt.z-beg_pt.z
      form_vec = Geom::Vector3d.new d_x,d_y,d_z
      re_vec = form_vec.normalize!
   return form_vec #return vector
   
  end
  def sp_points_on_circle(center, vec, radius, numseg,rotAngle)
		axes =vec.axes
		center = Geom::Point3d.new(center)
		xaxis = axes[0]
		yaxis = axes[1]
		xaxis.length = radius
		yaxis.length = radius
    if(rotAngle==nil)
		rotAngle=0.0
    end
    # compute the points
    da = (Math::PI * 2) / numseg
    pts = []
    for i in 0...numseg do
        angle = rotAngle + (i * da)
		#angle = rotAngle - (i * da)
        cosa = Math.cos(angle)
        sina = Math.sin(angle)
        vec = Geom::Vector3d.linear_combination(cosa, xaxis, sina, yaxis)
        pts.push(center + vec)
    end
    # close the circle
    pts.push(pts[0].clone)
    pts
  end
  
  def drawCircle (center,vec,rad_drive,view)
    # centerpoint = Geom::Point3d.new 
    # direc_point = Geom::Point3d.new
    # dest_point = Geom::Point3d.new
    # centerpoint = point1.position
    # direc_point = point2.position
    # dest_point = point3.position
    # rads = centerpoint.distance dest_point 
    
    # dx = direc_point.x-centerpoint.x
    # dy = direc_point.y-centerpoint.y
    # dz = direc_point.z-centerpoint.z

    # vector = Geom::Vector3d.new dx,dy,dz
    # vector2 = vector.normalize!
    model = Sketchup.active_model
    entities = model.active_entities
	#edges = []
    if(not @Override) 
	    puts "Override=",@Override
		# dest_point = point3.position
		# rads = centerpoint.distance dest_point 
		edges = entities.add_circle center, vec, rad_drive, 36 
	else
	    puts "Draw rads drive"
		#edges = entities.add_circle center, vec, rad_drive, 36
		edges = Sketchup.active_model.entities.add_circle center, vec, rad_drive, 36 
	end 
	@cir_face = entities.add_face edges
	
    if not(@cir_face.normal.samedirection? @dir_vec)
		puts "change to initial direction"
		@cir_face.reverse!
	end
	#view.model.active_entities.add_circle(centerpoint,vector2,rads,36)
    #self.reset
	#@drawed = true
  end
 
  
 
 
 end   # end class
Sketchup.active_model.select_tool Circle_any_plan.new